Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/README
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/README	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/README	(revision 34921)
@@ -15,13 +15,14 @@
 hash value provides information about the tag (explained later).
 
-Twenty-five special keys (TABLE_NAME, SHORT_NAME, PROCESS_PROC, WRITE_PROC,
-CHECK_PROC, GROUPS, FORMAT, FIRST_ENTRY, TAG_PREFIX, PRINT_CONV, WRITABLE,
-TABLE_DESC, NOTES, IS_OFFSET, IS_SUBDIR, EXTRACT_UNKNOWN, NAMESPACE, PREFERRED,
-SRC_TABLE, PRIORITY, WRITE_GROUP, LANG_INFO, VARS, DATAMEMBER and SET_GROUP1)
-are used to provide additional information about a table. The special keys have
-names that are all capitalized to avoid possible conflicts with tag keys.  Below
-is an explanation of the meaning of each special key:
-
-  TABLE_NAME : Name of this table (set by GetTagTable()).
+Twenty-eight special keys (TABLE_NAME, SHORT_NAME, PROCESS_PROC, WRITE_PROC,
+CHECK_PROC, INIT_TABLE, GROUPS, FORMAT, FIRST_ENTRY, TAG_PREFIX, PRINT_CONV,
+WRITABLE, TABLE_DESC, NOTES, IS_OFFSET, IS_SUBDIR, EXTRACT_UNKNOWN, NAMESPACE,
+PREFERRED, PERMANENT, SRC_TABLE, PRIORITY, AVOID, WRITE_GROUP, LANG_INFO, VARS,
+DATAMEMBER and SET_GROUP1) are used to provide additional information about a
+table.  The special keys have names that are all capitalized to avoid possible
+conflicts with tag keys.  Below is an explanation of the meaning of each special
+key:
+
+  TABLE_NAME : Name of this table (set automatically by GetTagTable()).
 
   SHORT_NAME : Table name with leading "Image::ExifTool::" removed.
@@ -29,8 +30,10 @@
   PROCESS_PROC : Reference to a function used to process the directory for this
   table.  If PROCESS_PROC is not given, \&Image::ExifTool::Exif::ProcessExif is
-  assumed.  If PROCESS_PROC is set to 0, the tags are not added to the lookup.
-  The process proc returns 1 on success or 0 on failure, and takes 3 arguments:
-  0) reference to the ExifTool object, 1) reference to a directory information
-  hash (with the following entries:), 2) reference to the tag table hash.
+  assumed (except for QuickTime atoms for which
+  \&Image::ExifTool::QuickTime::ProcessMOV is the default).  If PROCESS_PROC is
+  set to 0, the tags are not added to the lookup. The process proc returns 1 on
+  success or 0 on failure, and takes 3 arguments: 0) reference to the ExifTool
+  object, 1) reference to a directory information hash (with the following
+  entries:), 2) reference to the tag table hash.
 
     Name        - Tag name for this SubDirectory entry (for verbose messages)
@@ -51,26 +54,30 @@
     LastIFD     - Used by WriteExif() to return offset of last IFD written
     ImageData   - Used by WriteExif() to avoid buffering large image data blocks
-
-  WRITE_PROC : Reference to a function to write all new tags for this directory.
-  The write proc returns the new directory data or undefined on error.  It takes
-  the same arguments as the process proc above except that the second argument
+    NoRefTest   - Flag to bypass "referenced by previous directory" test
+
+  WRITE_PROC : Function reference or name for writing this directory.  The
+  function returns the new directory data or undefined on error.  It takes the
+  same arguments as the process proc above except that the second argument
   (reference to directory information hash) is optional, and if specified gives
   information about the source directory for tags to be copied to the output.
 
   CHECK_PROC : Reference to a function which validates Raw values for writing.
-  The function takes three arguments: 0) ExifTool object reference, 1) tagInfo
-  reference, 2) value reference, and returns undefined (and possibly modifies
-  the input value) if successful, or an error message if there was a format
-  problem.  May set ExifTool CHECK_WARN datamember for success with a warning.
+  The function takes 3-4 arguments: 0) ExifTool object reference, 1) tagInfo
+  reference, 2) value reference, and 3) [optional] conversion type.  It returns
+  undefined (and possibly modifies the input value) if successful, or an error
+  message if there was a format problem.  May set ExifTool CHECK_WARN datamember
+  for success with a warning.
+
+  INIT_TABLE : Routine called to do any necessary initialization before the
+  first time the table is loaded.  Argument is a reference to the table.
 
   GROUPS : A hash lookup for the default group names for all entries in this
-  table. If not specified, the Group 0 and 1 names will be set automatically
-  according to the name of the module.
-
-  FORMAT : Specifies the default tag Format and corresponding pointer increment
-  for entries in a BinaryData table, and defaults to 'int8u' if not specified.
-  Format names starting with 'var_' cause subsequent tag ID's in BinaryData
-  tables to be incremented according to the size of the data (not including the
-  terminator).  The possible values of FORMAT are:
+  table.  If not specified, the default Group 0 and 1 names will be set
+  automatically according to the name of the module, and the default Group 2
+  name will be set to 'Other'.
+
+  FORMAT : Specifies the default tag Format, and corresponding pointer increment
+  for entries in a BinaryData table.  Defaults to 'int8u' for BinaryData tables
+  if not specified.  The possible values of FORMAT are:
 
     int8s       - Signed 8-bit integer                    (EXIF 'SBYTE')
@@ -96,13 +103,33 @@
     ifd         - Unsigned 32-bit integer sub-IFD pointer (EXIF 'IFD')
     ifd64       - Unsigned 64-bit integer sub-IFD pointer (BigTIFF 'IFD8')
-    string      - Series of 8-bit ASCII characters        (EXIF 'ASCII')
-    pstring     - Pascal string [BinaryData tables only]
+    string      - Series of 8-bit characters              (EXIF 'ASCII')
     undef       - Undefined-format binary data            (EXIF 'UNDEFINED')
-    binary      - Binary data
-    var_string  - variable-length null-terminated ASCII string [BinaryData]
-    var_ustring - variable-length null-terminated UCS-2 string [BinaryData]
-    var_pstring - variable-length Pascal string                [BinaryData]
-    var_pstr32  - variable-length Pascal string /w 32-bit len  [BinaryData]
-    var_int16u  - variable-length undef data with int6u count  [BinaryData]
+    binary      - Binary data (same as 'undef')
+
+  Additionally, the following variable-length Format types may be used in
+  individual tag information hashes of a BinaryData table.  The 'var_' formats
+  cause subsequent tag indices to be incremented according to the size of the
+  data, not including the terminator.  See "Format" below for more details.
+
+    pstring     - Pascal string (1-byte length followed by ASCII string)
+    var_string  - variable-length null-terminated ASCII string
+    var_ustring - variable-length null-terminated UCS-2 string
+    var_pstring - variable-length Pascal string
+    var_pstr32  - variable-length Pascal string /w 32-bit len
+    var_ustr32  - variable-length UCS-2 string /w 32-bit len
+    var_int16u  - variable-length undef data with int6u count
+    var_ue7     - variable-length 7-bit-at-a-time integer (BPG)
+
+  And the following format codes are used for string values in XMP metadata.
+  (See the XMP specification for more details.)
+
+    boolean     - "True" or "False"
+    date        - date/time string
+    integer     - integer as a string
+    lang-alt    - list of alternate-language strings
+    rational    - "N/D" where N=numerator, D=Denominator
+    real        - floating point value as a string
+    string      - unformatted string
+    struct      - structure
 
   FIRST_ENTRY : Specifies the index for the first tag entry in a binary table.
@@ -124,11 +151,11 @@
 
   NOTES : Notes to introduce the table in the TagNames documentation.  Pod
-  formatting codes B<> and C<> may be used in this text.
-
-  IS_OFFSET : Reference to list of sorted TagID's representing offsets for
-  writable binary data tables only.  Not used for EXIF tables.
-
-  IS_SUBDIR : BinaryData tables only.  A reference to a list of sorted tag ID's
-  representing subdirectories.  Required for writable subdirectories only.
+  formatting codes B<>, C<> and L<> may be used in this text.
+
+  IS_OFFSET : Writable BinaryData tables only.  Reference to list of sorted
+  TagID's representing offsets.
+
+  IS_SUBDIR : Writable BinaryData tables only.  A reference to a list of sorted
+  tag ID's representing subdirectories.
 
   EXTRACT_UNKNOWN : Used in PDF tables to specify a directory where all unknown
@@ -137,20 +164,29 @@
 
   NAMESPACE : Namespace prefix for tags in the XMP table.  If this isn't a
-  standard (pre-defined) namespace, then the URI must be defined as well.  To do
-  this, the NAMESPACE value is a reference to either a list or a hash, where the
-  first element (or hash key) is the namespace prefix and and the second element
-  (or hash value) is the URI.  This is undef for XMP tables in which tags have
-  variable namespaces, and in this case each tag must have a Namespace entry.
+  standard namespace defined in %Image::ExifTool::XMP::nsURI, then the URI must
+  be defined as well (however, this is not recommended for pre-defined
+  namespaces because then non-standard namespace prefixes won't be recognized).
+  To define the URI, the NAMESPACE value is a reference to a hash where the key
+  is the namespace prefix and and the value is the URI (alternatively, a
+  reference to a 2-element array containing the prefix and URI is also allowed
+  for backward compatibility).  The NAMESPACE value may be undef for XMP tables
+  where tags have variable namespaces (in this case each tag must have a
+  Namespace entry).
 
   PREFERRED : Set to true if the tags in this table should always be added when
   writing information.  Overrides the order specified by SetNewGroups().  When
-  this feature is used, it may also be desireable to specify a preferred group
+  this feature is used, it may also be desirable to specify a preferred group
   when calling InitWriteDirs() to write these tags; this avoids creating other
   directories for tags which are already being creating in the preferred group.
 
+  PERMANENT : Tags in this table are Permanent, and can't be deleted.  Maker
+  notes tags are Permanent by default, without the need to set this property.
+
   SRC_TABLE : Used internally to store the source table name of a user-defined
   tag table so the appropriate module can be loaded as required.
 
   PRIORITY : Default Priority for all tags in this table.
+
+  AVOID : Flag set to Avoid writing all tags in this table.
 
   WRITE_GROUP : Default WriteGroup for all tags in the table.
@@ -159,5 +195,5 @@
   language-specific tag information hash.  The routine takes two arguments: a
   reference to the non-specific tagInfo hash, and the language code. Used only
-  in tables with writable tags which support tag name language extensions (ie.
+  in tables with writable tags which support tag name language extensions (eg.
   MIE and XMP).
 
@@ -168,9 +204,16 @@
     ID_LABEL      Label to use instead of "Tag ID" for column heading in tag
                   name documentation.  When this is set, numerical TagID's are
-                  not converted to hexadecimal notation. Unless otherwise set,
+                  not converted to hexadecimal notation.  Unless otherwise set,
                   an ID_LABEL of "Index" is assumed for tables which use
                   ProcessBinaryData.
 
     NO_ID         Avoid printing "Tag ID" column in tag name documentation.
+
+    HEX_ID        Print tag ID in hexadecimal (with 4 hex digits or more).  Set
+                  to 0 for string ID's that look like hex numbers to prevent
+                  them from being converted when importing an XML file for
+                  language translations in BuildLangModules().
+
+    NO_LOOKUP     Do not add tags to TagLookup.pm lookup tables.
 
     CAPTURE       Used by PDF module to name dictionaries to capture when
@@ -183,5 +226,24 @@
                   the entire IFD from the image.
 
-    NUMBERS_LAST  Sort numerical tags after character tags in documentation.
+    ALPHA_FIRST   Sort alphabetical tags before numerical in documentation.
+
+    LONG_TAGS     Suppress "Long tags" warning when generating documentation.
+                  Value is the number of long tag names to expect.
+
+    SORT_PROC     Reference to sort procedure for sorting tag ID's in the
+                  documentation.  Takes two arguments and returns -1, 0 or 1
+                  if the first argument is less than, equal to, or greater than
+                  the second argument.
+
+    ENTRY_SIZE    Used by ProcessPhaseOne to specify size of IFD entry
+
+    MAP_FORMAT    Lookup to map unknown format numbers (eg. Panasonic CameraIFD)
+
+    START_INDEX   [QuickTime tables only] Initial index for indices shown in
+                  Verbose output.  Indices are not show otherwise.
+
+    ATOM_COUNT    [QuickTime tables only] Maximum number of atoms contained in
+                  within this atom.  Currently used only for Canon CNTH atom,
+                  which contains garbage after the first contained atom.
 
   DATAMEMBER : BinaryData tables only.  A reference to a list of sorted tag ID's
@@ -200,5 +262,5 @@
 conditions.  The following is a description of possible hash entries.  All
 entries are optional, except for the tag Name which is required if the tag ID is
-numerical.
+numerical, and generated automatically otherwise.
 
   Name          : The tag name.  Tag names need not be unique.  If they aren't
@@ -210,7 +272,7 @@
                   to the form "TagName (N)", where N starts at 1 and increments
                   for subsequent duplicate tags.  A tag name should start with
-                  an uppercase letter, and contain only the charcters in the set
-                  [A-Za-z0-9_-].  If not given, the Name is taken from the tag
-                  ID with the first character changed to upper case.
+                  an uppercase letter, and contain only the characters in the
+                  set [A-Za-z0-9_-].  If not given, the Name is taken from the
+                  tag ID with the first character changed to upper case.
 
   Description   : A more readable description of tag name.  If a tag doesn't
@@ -220,7 +282,8 @@
   Notes         : Notes for this tag in the HTML TagNames documentation.
 
-  Groups        : Hash lookup for group names for this tag.
-
-  Format        : Only valid for BinaryData, EXIF and IPTC tables. For a Binary
+  Groups        : Hash lookup for group names for this tag.  If not specified,
+                  defaults to the GROUPS specified in the table definition.
+
+  Format        : Only valid for BinaryData, EXIF and IPTC tables.  For a Binary
                   or EXIF table, this gives the format that is used to convert
                   the binary data, and is one of the FORMAT types specified
@@ -232,15 +295,17 @@
                   Condition.  For BinaryData tables, the format may have a size
                   in trailing brackets which is a Perl expression to be
-                  evaluated. The expression may access any of the previous table
-                  entries through a %val hash (read-only tables), the data size
-                  via $size, or the ExifTool object via $self. For example,
-                  'string[$val{3}]' defines a string with length given by the
-                  table entry with tag index '3'.  An initial "var_" may be
-                  added to the Format name of any BinaryData tag with a size in
-                  brackets.  In this case, subsequent offsets are adjusted by
-                  the total size minus the size of the base Format (ie.
-                  "var_int16u[10]" causes subsequent offsets to be incremented
-                  by sizeof(int16u) * 9).  Note that all "var_" Format tags must
-                  have corresponding DATAMEMBER entries.
+                  evaluated.  The expression may access any of the previous
+                  table entries through a %val hash (read-only tags), the data
+                  size via $size, or the ExifTool object via $self.  For
+                  example, 'string[$val{3}]' defines a string with length given
+                  by the table entry with tag index '3'.  An initial "var_" may
+                  be added to the Format name of any BinaryData tag with a size
+                  in brackets.  In this case, subsequent offsets are adjusted by
+                  the value length minus the size of the default table FORMAT
+                  (eg. "var_int16u[10]" causes subsequent offsets to be
+                  incremented by sizeof(int16u) * 10 - sizeof(int8u) if the
+                  default table FORMAT is "int8u").  Note that all "var_" Format
+                  tags (as well as tags with values used within "var_" Format
+                  expressions) must have corresponding DATAMEMBER entries.
 
   Count         : Used when writing EXIF information to specify the number
@@ -248,7 +313,8 @@
                   string.  A value of -1 indicates that the count is variable
                   and should be determined by the number of values provided.
-                  Note that this count that corresponds to the specified Format,
-                  so if a different-sized Writable format is defined, the actual
-                  count written to the file will be different.
+                  Defaults to 1 if not specified for non-string formats.  Note
+                  that this count corresponds to the specified Format, so if a
+                  different-sized Writable format is defined, the actual count
+                  written to the file will be different.
 
   FixCount      : Flag set to determine correct count from offsets in IFD.  This
@@ -258,8 +324,8 @@
   Flags         : Flags to specify characteristics for this tag.  May be a
                   simple scalar flag name, a reference to a list of flag names,
-                  or a reference to a hash of flag/value pairs. If not a hash
-                  reference, the flag value is set to 1. Flags are expanded for
+                  or a reference to a hash of flag/value pairs.  If not a hash
+                  reference, the flag value is set to 1.  Flags are expanded for
                   faster access at run time into members of the tagInfo hash,
-                  and may be written directly as members if desired. The
+                  and may be written directly as members if desired.  The
                   available flag names are:
 
@@ -269,5 +335,6 @@
 
                   'Avoid' - avoid creating this tag if possible.  This is only
-                  effective if another tag exists with the same name.
+                  effective if another tag exists with the same name.  Setting
+                  this flag also sets the default Priority to 0 for this tag.
 
                   'Binary' - set to 1 for binary data.  This has the same effect
@@ -280,5 +347,11 @@
                   information which are extracted by default.  Otherwise
                   writable directories are only extracted as a block if
-                  specified explicitly.
+                  specified explicitly.  Also used for Jpeg2000 and QuickTime
+                  XMP-like tags to extract as a block with a name other than
+                  'XMP'.
+
+                  'ConvertBinary' - true to apply ValueConv and/or PrintConv to
+                  Binary values (ie. SCALAR references).  (By default, these
+                  conversions are not done for Binary values.)
 
                   'DataMember' - name of exiftool data member associated with
@@ -287,5 +360,5 @@
                   affects other written information.  Currently only used for
                   tags in EXIF tables where it triggers the execution of the
-                  RawConv to convert and stores the value as an ExifTool data
+                  RawConv to convert and store the value as an ExifTool data
                   member when writing.
 
@@ -293,6 +366,12 @@
                   byte count tags.
 
-                  'Drop' - set to 1 for tags that should be excluded when
-                  rebuilding maker notes when copying all tags.
+                  'DelGroup' - set if deleting this tag is the same as deleting
+                  the group of the same name.
+
+                  'Drop' - [IFD-format and PhaseOne makernote tags only] set to
+                  1 for tags that should be excluded when rebuilding maker notes
+                  when copying all tags.  Set to a number larger than 1 to drop
+                  only if data is larger than this size. Works for SubDirectory
+                  tags too.
 
                   'EntryBased' - set to 1 if the offset for this value is based
@@ -310,9 +389,14 @@
                   which have been processed to generate flattened equivalents.
 
-                  'GotGroups' - [reserved] flag used internally to indicate that
-                  the Groups hash has been initialized for this tag.
-
-                  'Hidden' - set to hide tag from the TagName documentation. 
+                  'NotFlat' - [XMP tags only] Flag indicates that this tag ID
+                  does not represent a flattened tag.  Used to avoid a conflict
+                  if the tag ID would be the same as a generated ID for a
+                  flattened tag.  The result is that the flattened tag will not
+                  be accessible.
+
+                  'Hidden' - set to hide tag from the TagName documentation.
                   Also suppresses verbose output of a BinaryData tag.
+
+                  'IsComposite' - flag set for Composite tags
 
                   'IsOffset' - flag set if the tag represents an offset to some
@@ -322,5 +406,5 @@
                   (only some maker notes are this messed up).  Set to 3 if
                   absolute file offsets are used.  May be set to an expression
-                  to be evaluated.  Expression may access $val and $exifTool,
+                  to be evaluated.  Expression may access $val and $et,
                   and is evaluated only when reading.
 
@@ -331,7 +415,7 @@
                   well, a value of '1' is used internally in XMP to allow list
                   behaviour for a flattened tag which is itself not a list
-                  element (ie. a member of list of structures).  Note that in
+                  element (eg. a member of list of structures).  Note that in
                   ExifTool an XMP lang-alt tag (Writable="lang-alt") is NOT a
-                  List-type tag (unless it is a list of lang-alt lists, which is
+                  list-type tag (unless it is a list of lang-alt lists, which is
                   uncommon).
 
@@ -342,5 +426,5 @@
 
                   'Mandatory' - set for mandatory tags.  Used only by TagInfoXML
-                  and documentation purposes.  Mandatory tags may be added
+                  and for documentation purposes.  Mandatory tags may be added
                   automatically by ExifTool.
 
@@ -350,7 +434,8 @@
                   only be underlined if nested inside other maker notes.
 
-                  'NotIFD' - set for 'MakerNotes' tags only if the data is not
-                  in standard EXIF IFD format.  (Note: All SubDirectory tags in
-                  the MakerNotes table are 'MakerNotes' type by default.)
+                  'NotIFD' - set for 'MakerNotes' SubDirectory tags only if the
+                  SubDirectory is not EXIF IFD format.  (Note: All SubDirectory
+                  tags in the MakerNotes table are 'MakerNotes' type by
+                  default.)
 
                   'OffsetPair' - set if the tag represents half of an offset/
@@ -364,7 +449,11 @@
 
                   'PrintHex' - specifies that unknown PrintConv values should
-                  be printed in hex (ie. 'Unknown (0x01)').  Also causes
+                  be printed in hex (eg. 'Unknown (0x1)').  Also causes
                   numerical tag values to be printed in hex in the HTML tag name
-                  documentation.
+                  documentation, padded to the number of digits given by the
+                  PrintHex value.
+
+                  'PrintSort' - causes PrintConv values to be sorted by value
+                  rather than key in the HTML tag name documentation.
 
                   'PrintString' - flag set to force PrintConv values to be
@@ -390,6 +479,12 @@
                   'PutFirst' - [EXIF only] flag to place this value before IFD0
                   when writing (ie. immediately after TIFF header).  Only used
-                  for main IFD's (IFD0, IFD1, etc) and IFD's where SubIFD flag
-                  is set to 2 (currently only ExifIFD).
+                  for values in main IFD's (IFD0, IFD1, etc) and IFD's where
+                  SubIFD flag is set to 2 (currently only ExifIFD).
+
+                  'RawJoin' - [List tags only] Joins raw List-type tag values
+                  into a single string with a space separator, allowing
+                  ValueConv and PrintConv to act on the concatenated string so
+                  the tag does not exhibit list-type behaviour.  When writing,
+                  the inverse is performed and the value is split at whitespace.
 
                   'Resource' - [XMP only] flag to write value as an rdf:resource
@@ -403,5 +498,5 @@
 
                   'SetResourceName' - [Photoshop tags only] set to 1 to append
-                  resource name to the extracted value (ie. 'VALUE/#NAME#/').
+                  resource name to the extracted value (eg. 'VALUE/#NAME#/').
                   Also allows resource name to be appended when writing new
                   values.  May be set to any value other than 1 for a default
@@ -413,20 +508,31 @@
                   more enclosing structures has a TYPE field.
 
-                  'SubDoc' - [Composite tags only] set to cause this composite
+                  'SubDoc' - [Composite tags only] set to cause this Composite
                   tag to also be generated for each sub-document.  To achieve
                   this, 'Main:' and 'Doc#:' prefixes are added to all Require'd
                   and Desire'd tag names which don't already start with 'Main:'
-                  or 'Doc#:', and the composite tag is built once for each of
-                  the main document and all sub-documents.
+                  or 'Doc#:', and the Composite tag is built once for each of
+                  the main document and all sub-documents.  May be a reference
+                  to a list of indices for Desire'd tags, one of which must
+                  exist to generate this tag for sub-documents.
 
                   'SubIFD' - used in writing to determine that the tag specifies
                   an offset to a sub-IFD.  When this flag is set, the Group1
                   name gives the name of the IFD.  Must be set if and only if
-                  the tag has a SubDirectory Start of '$val' (this is validated
-                  by BuildTagLookup).  Set to 2 for standard EXIF SubIFD's where
-                  the PutFirst flag is valid.
+                  the tag has a SubDirectory Start that references '$val' (this
+                  is validated by BuildTagLookup).  Set to 2 for standard EXIF
+                  SubIFD's where the PutFirst flag is valid.
 
                   'Unknown' - this is an unknown tag (only extracted when the
                   Unknown option is set).
+
+                  'WriteNothing' - flag indicating that nothing is actually
+                  written when this tag is set.  It is a fake writable tag that
+                  isn't actually written (eg. Geotag).  Used to avoid processing
+                  a file unnecessarily if nothing will actually be written.
+
+                  'WritePseudo' - flag indicating that this is a writable pseudo
+                  tag.  If set, this tag may be written without actually writing
+                  to the file (eg. FileName, FileModifyDate).
 
                   'WrongBase' - ['IsOffset' tags only] An expression using $self
